
ArrayList<PlaySpace> spaces = new ArrayList<PlaySpace>();

void setup(){
  size(500,750);
  spaces.add(new Cans(0,0));
  spaces.add(new Attention(1,0));
  spaces.add(new Gears(0,1));
  spaces.add(new Tris(1,1));
  spaces.add(new Spiral(0,2));
  spaces.add(new Break(1,2));
}
void draw(){
 
  for(PlaySpace ps : spaces){
     ps.draw(); 
  }
}

PlaySpace currentSpace;

void keyPressed(){
   if(currentSpace != null){
      currentSpace.keyPressed(key);
   } 
}


void mousePressed(){
   PlaySpace newSpace = findSpace();
   if(newSpace == null) return;
   newSpace.mousePressed(mouseX,mouseY);
   currentSpace = newSpace;
}

void mouseReleased(){
   PlaySpace newSpace = findSpace();
   if(newSpace == null) return;
   newSpace.mouseReleased(mouseX,mouseY);
   
}

void mouseDragged(){
   PlaySpace newSpace = findSpace();
   if(newSpace == null) return;
   newSpace.mouseDragged(mouseX,mouseY);
 
}

void mouseMoved(){
     PlaySpace newSpace = findSpace();
   if(newSpace == null) return;
   newSpace.mouseMoved(mouseX,mouseY);
}


PlaySpace findSpace(){
   for(PlaySpace ps : spaces){
      if(ps.isIn(mouseX,mouseY)){
         return ps; 
      }
   } 
   return null;
}


class Pair{
  float x,y;
  Pair(float px,float py){
      x = px; y = py;
  }
}





int GRIDSIZE = 2;

abstract class PlaySpace{
  
  boolean isIn(float mx, float my){
    if( mx >= x * w && mx < (x+1)* w){
       if(my >= y * h && my < (y+1)*h){
          return true;
          
       } 
    }
  return false;
  }
  color bgc;
  int x, y;
  float w,h;
   PlaySpace(int px, int py){
    bgc = color(random(32,128));
    x = px;
    y = py;
    w = width/2;
    h = height/3;
   } 
   void draw(){
     pushMatrix();
     noStroke();
    translate(x*w,y*w);
    
      run();
    popMatrix();
   } 
  abstract void run();
  void mousePressed(float mx, float my){
    doMousePressed(mx - (x*w),my-(y*h));
  }
  void doMousePressed(float x, float y){}

  void mouseReleased(float mx, float my){
    doMouseReleased(mx - (x*w),my-(y*h));
  }
  void doMouseReleased(float x, float y){}

  void mouseDragged(float mx, float my){
    doMouseDragged(mx - (x*w),my-(y*h));
  }
  void doMouseDragged(float x, float y){}
  
  void mouseMoved(float mx, float my){
    doMouseMoved(mx - (x*w),my-(y*h));
  }
  void doMouseMoved(float x, float y){}
  
  void keyPressed(char k){
     if(k == ' '){
      reset();
     } 
  }
  void reset(){
    
  }
  
}
